﻿using System;
using System.Collections.Generic;
using System.Text;

namespace reversi
{
    class Board
    {
        // These constants represent the contents of a board square.
        public static readonly int Black = -1;
        public static readonly int Empty = 0;
        public static readonly int White = 1;

       // These counts reflect the current board situation.
        // Internal counts.
        public  int BlackCount { get; set; }
        public  int WhiteCount { get; set; }
        public  int EmptyCount { get; set; }
        public  int BlackFrontierCount { get; set; }
        public  int WhiteFrontierCount { get; set; }
        public  int BlackSafeCount { get; set; }
        public  int WhiteSafeCount { get; set; }
       // This two-dimensional array represents the squares on the board.
        public  int[,] squares { get; set; }
        
        // This two-dimensional array tracks which discs are safe (i.e.,
        // discs that cannot be outflanked in any direction).
       public  bool[,] safeDiscs;
       private  Movement movement;
        //
        // Creates a new, empty Board object.
        //
        public Board()
        {
            //
            // TODO: Add constructor logic here
            //

            // Create the squares and safe disc map.
            this.squares = new int[8, 8];
            this.safeDiscs = new bool[8, 8];

            // Clear the board and map.
            int i, j;
            for (i = 0; i < 8; i++)
                for (j = 0; j < 8; j++)
                {
                    this.squares[i, j] = Board.Empty;
                    this.safeDiscs[i, j] = false;
                }

            // Update the counts.
            this.movement = new Movement(this);
          this.movement.UpdateCounts();
        }

        //
        // Creates a new Board object by copying an existing one.
        //
        public Board(Board board)
        {
            // Create the squares and map.
            this.squares = new int[8, 8];
            this.safeDiscs = new bool[8, 8];

            // Copy the given board.
            int i, j;
            for (i = 0; i < 8; i++)
                for (j = 0; j < 8; j++)
                {
                    this.squares[i, j] = board.squares[i, j];
                    this.safeDiscs[i, j] = board.safeDiscs[i, j];
                }

            // Copy the counts.
            this.BlackCount = board.BlackCount;
            this.WhiteCount = board.WhiteCount;
            this.EmptyCount = board.EmptyCount;
            this.BlackSafeCount = board.BlackSafeCount;
            this.WhiteSafeCount = board.WhiteSafeCount;
        }
      
       
   


    }
}
