using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Data;
using System.Windows.Forms;

namespace reversi
{
    public class SquareControl : System.Windows.Forms.UserControl
	{
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
        public static Color NormalBackColor= Color.Green;
	    // This represents the contents of the square, see the values defined
		// in the Board class.
		public int Contents;
		public int PreviewContents;
       // These reflect the position of the square on the board.
		public int col{get;set;}
		public int row{get;set;}
		// Drawing tools.
		private static Pen pen = new Pen(Color.Black);
		private static SolidBrush solidBrush = new SolidBrush(Color.Black);
	    public SquareControl(int row, int col)
		{
		// This call is required by the Windows.Forms Form Designer.
		InitializeComponent();
         this.Contents = Board.Empty;
		this.row = row;
		this.col = col;
        // Prevent the control from receiving focus via the TAB key.
		this.TabStop = false;
        // Set the background color.
		this.BackColor = SquareControl.NormalBackColor;
         }

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            // SquareControl
			this.Name = "SquareControl";
			this.Size = new System.Drawing.Size(32, 32);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.SquareControl_Paint);
        }
		#endregion
        private void SquareControl_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
            // Set drawing options.
            e.Graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
            // Draw the disc, if any.
			if (this.Contents != Board.Empty || this.PreviewContents != Board.Empty)
			{
				// Get size and position parameters based on the control size.
				int size      = (int) (this.Width * (0.80));
				int offset    = (int) ((this.Width - size) / 2);
				int thickness = (int) (size * 0.08);
				int width     = size;
                int height    = size; 
				int left      = offset;
				int top       = offset + (int) Math.Round((double) (size - height) / 2.0);
                 // Draw the disc face, if not on edge.
				
				if (this.PreviewContents == Board.Empty)
					{
						if (this.Contents == Board.Black)
						{
							SquareControl.solidBrush.Color = Color.Black;

					       }
						else
						{
                            SquareControl.solidBrush.Color = Color.Silver;

						}
					e.Graphics.FillEllipse(SquareControl.solidBrush, left, top, width, height);
            }
			}
            // Draw the border.
            Point topLeft = new Point(0, 0);
            Point topRight = new Point(this.Width - 1, 0);
            Point bottomLeft = new Point(0, this.Height - 1);
            Point bottomRight = new Point(this.Width - 1, this.Height - 1);
            SquareControl.pen.Color = Color.Moccasin;
            SquareControl.pen.Width = 1;
            e.Graphics.DrawLine(SquareControl.pen, bottomLeft, topLeft);
            e.Graphics.DrawLine(SquareControl.pen, topLeft, topRight);
            SquareControl.pen.Color = Color.Navy;
            e.Graphics.DrawLine(SquareControl.pen, bottomLeft, bottomRight);
            e.Graphics.DrawLine(SquareControl.pen, bottomRight, topRight);
		}
	}
}
